package ru.landgrafhomyak.serdha.api.v0.queries

import ru.landgrafhomyak.serdha.api.v0.misc.Expression
import ru.landgrafhomyak.serdha.api.v0.misc.DatabaseType
import ru.landgrafhomyak.serdha.api.v0.misc.SelectedTable

public interface SelectQuery<QueryUserExtension : Any> : _Selectable<QueryUserExtension> {
	public val userExtension: QueryUserExtension

	public enum class Order {
		ASC, DESC
	}

	@Suppress("ClassName")
	public interface _CommonSelectCreatorScope<QueryUserExtension : Any> {
		public fun where(expression: Expression<Boolean, DatabaseType.BOOLEAN, QueryUserExtension>)

		public var limit: UInt

		public var offset: ULong
	}

	public interface JoinCreator<QueryUserExtension : Any, LeftTableUserExtension : Any, RightTableUserExtension : Any> : _CommonSelectCreatorScope<QueryUserExtension> {
		public fun createSelectWithJoin(creator: Scope<QueryUserExtension, LeftTableUserExtension, RightTableUserExtension>): QueryUserExtension

		public interface Scope<QueryUserExtension : Any, LeftTableUserExtension : Any, RightTableUserExtension : Any> {
			public val leftTable: SelectedTable<LeftTableUserExtension, QueryUserExtension>
			public val rightTable: SelectedTable<RightTableUserExtension, QueryUserExtension>
		}
	}

	public interface Creator<QueryUserExtension : Any, TableUserExtension : Any> {
		public fun createSelect(creator: Scope<QueryUserExtension, TableUserExtension>): QueryUserExtension

		public interface Scope<QueryUserExtension : Any, TableUserExtension : Any> : _CommonSelectCreatorScope<QueryUserExtension> {
			public val selectedTable: TableUserExtension
		}
	}
}