package ru.landgrafhomyak.serdha.api.v0.queries

import ru.landgrafhomyak.serdha.api.v0.misc.Expression
import ru.landgrafhomyak.serdha.api.v0.misc.Column
import ru.landgrafhomyak.serdha.api.v0.misc.DatabaseType
import ru.landgrafhomyak.serdha.api.v0.misc.DatabaseTypesProvider
import ru.landgrafhomyak.serdha.api.v0.misc.Input
import ru.landgrafhomyak.serdha.api.v0.runtime.ParametersSetter

@Suppress("ClassName")
public interface _CommonCreateQueryScope<QueryUserExtension : Any> {
	public val types: DatabaseTypesProvider

	public val expressionBuilder: Expression.Builder<QueryUserExtension>

	public interface SubqueryParametersSetter<SubqueryUserExtension : Any, QueryUserExtension : Any> : ParametersSetter<SubqueryUserExtension> {
		public operator fun <RT, DT : DatabaseType<RT>> set(c: Input.QueryParam<RT, DT, QueryUserExtension>, value: Expression<RT, DT, QueryUserExtension>)
	}

	public interface _ReturningClauseScope<QueryUserExtension : Any> {
		public fun <RT, DT : DatabaseType<RT>> returnExpression(expression: Expression<RT, DT, QueryUserExtension>): Column<RT, DT, QueryUserExtension>

		public var isDistinct: Boolean

		public fun orderBy(order: SelectQuery.Order, vararg columns: Column<*, *, QueryUserExtension>)

		public fun groupBy(vararg columns: Column<*, *, QueryUserExtension>)
	}
}